unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText5: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    StaticText2: TStaticText;
    StaticText7: TStaticText;
    StaticText6: TStaticText;
    EditMaxLevels: TEdit;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    Button3: TButton;
    EditEq: TEdit;
    StaticText1: TStaticText;
    procedure Construction(Sender: TObject);
{    procedure Init(Sender: TObject);}
    procedure Konec(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
    procedure SetStop(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;
  Stop         : Boolean;
implementation

uses Graph2D_2005;

{$R *.DFM}

procedure TControl_Panel.Construction(Sender: TObject);
  var Max,Min  :Double;
      i,j,k,l,m,MaxLevel:integer;
      F        :TPixel;
      Hodn     :Double;
      Pixel    :Byte;
      RealPixel:Double;
      Matrix   :array [0..1400,0..900] of byte;
      c        :array [0..2,0..2] of Double;
      Eq,ErrorReport:String;
      Expression    :TExpression;

  procedure Setting;
  var Number:Real;
    Code :Integer;
  begin
   Val(EditX1.Text,Number,Code);Draw2D.x1:=Number;
   Val(EditX2.Text,Number,Code);Draw2D.x2:=Number;
   Val(EditY1.Text,Number,Code);Draw2D.y1:=Number;
   Val(EditY2.Text,Number,Code);Draw2D.y2:=Number;
   Eq:=EditEq.Text;
   Val(EditMaxLevels.Text,Number,Code);MaxLevel:=Trunc(Number);
  end;

begin
  Setting;Stop:=False;
  With Draw2D do
    begin
      hx:=(x2-x1)/Image1.Width;
      hy:=(y2-y1)/Image1.Height;
{*************************************}
{***** Stanoveni oboru hodnot ********}
{*************************************}

  Expression:=PreCalc(Eq,ErrorReport);i:=0;F[1]:=0;
  y:=y1;x:=x1;
  Min:=PostCalc(Expression,ErrorReport);Max:=Min;
  Repeat
   x:=x1;
    Repeat
      Hodn:=PostCalc(Expression,ErrorReport);
      if Hodn>max then Max:=hodn else if hodn<Min then Min:=hodn;
      x:=x+hx;
    Until x>x2-hx;
    y:=y+hy;F[2]:=i;
    PutPixel(F,255,0,0);
    i:=succ(i);
    if i mod 30 = 0 then begin
                         Image1.Repaint;
                         Application.ProcessMessages;
                         if Stop then exit;
                         end;
  until y>y2-hy;
  Scale(x1,x2,y1,y2);
  y:=y2;j:=0;
  Repeat
    x:=x1;i:=0;F[2]:=j;
    Repeat
      Hodn:=PostCalc(Expression,ErrorReport);F[1]:=i;
      m:=Round((hodn-Min)*MaxLevel/(Max-Min))+2;
      if odd(m) then begin Red:=255;Green:=255;Blue:=0;Matrix[i,j]:=0;end
                else begin Red:=0;Green:=0;Blue:=255;Matrix[i,j]:=255;end;
      PutPixel(F,Red,Green,Blue);
      inc(i);
      x:=x+hx;
    Until x>x2-hx;
    Canvas.Pixels[i,0]:=Color;
    y:=y-hy;inc(j);
    if j mod 30 = 0 then begin
                         Image1.Repaint;
                         Application.ProcessMessages;
                         if Stop then exit;
                         end;
  until y<y1+hy;
 end;
 C[0,0]:=-1/8;C[0,1]:=-1/8;C[0,2]:=-1/8;
 C[1,0]:=-1/8;C[1,1]:= 1  ;C[1,2]:=-1/8;
 C[2,0]:=-1/8;C[2,1]:=-1/8;C[2,2]:=-1/8;
 For j:=2 to Draw2D.Image1.Height-2 do
 begin
    F[2]:=j;
    For i:=2 to Draw2D.Image1.Width-2 do
    begin
     F[1]:=i;
     RealPixel:=0;
     for k:=i-1 to i+1 do
       for l:=j-1 to j+1 do
         RealPixel:=RealPixel+Matrix[k,l]*C[k-i+1,l-j+1];
     if RealPixel>128 then RealPixel:=128;
     if RealPixel<-127 then RealPixel:=-127;
     Pixel:=Trunc(RealPixel)+127;
     With Draw2D do
     begin
     if Pixel<127 then begin Red:=0;Green:=0;Blue:=200;end
                  else begin Red:=255;Green:=255;Blue:=255;end;
     PutPixel(F,Red,Green,Blue);
     end;
   end;
   if j mod 30 = 0 then begin
                         Draw2D.Image1.Repaint;
                         Application.ProcessMessages;
                         if Stop then exit;
                         end;
 end;
 Draw2D.Image1.Repaint;
end;

procedure TControl_Panel.Konec(Sender: TObject);
begin
  Draw2D.Visible:=False;Halt;
end;


procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    Left:=350;Top:=0;
    ClientWidth:=700;ClientHeight:=700;
    InitImage(700,700);ClearImage(255,255,255);
    Caption:='Function z=f(x,y) - Contour Lines';
    Visible:=True;
  end;

end;

procedure TControl_Panel.SetStop(Sender: TObject);
begin
  Stop:=True;
end;

end.
