unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtDlgs;

type
  TControl_Panel = class(TForm)
    Start_Button: TButton;
    ExitButton: TButton;
    StaticText5: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    StaticText2: TStaticText;
    StaticText7: TStaticText;
    StaticText13: TStaticText;
    EditIter: TEdit;
    StaticText14: TStaticText;
    EditDiam: TEdit;
    StopButton: TButton;
    StaticText4: TStaticText;
    StaticText6: TStaticText;
    SaveButton: TButton;
    SavePictureDialog1: TSavePictureDialog;
    StaticText8: TStaticText;
    EditG1: TEdit;
    StaticText9: TStaticText;
    EditG2: TEdit;
    StaticText11: TStaticText;
    Procedure Triangles(Sender: TObject);
    Procedure Exit(Sender: TObject);
    Procedure SetGraph2D(Sender: TObject);
    Procedure SetY2(Sender: TObject);
    Procedure SetStop(Sender: TObject);
    Procedure ImageSave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

    Eq1, Eq2: String;
    Procedure Setting;

  end;

var Control_Panel: TControl_Panel;

implementation

uses Graph2d_2005;
var Error: String;
    ExpressG1,ExpressG2: TExpression;
    MaxIter: Integer;
    Diam, C1, C2: Double;
    Stop: Boolean;

{$R *.DFM}

Procedure TControl_Panel.Setting;

var Code: Integer;

begin
 With Draw2D Do
  begin
   Val(EditX1.Text, x1, Code);
   Val(EditX2.Text, x2, Code);
   Val(EditY1.Text, y1, Code);
   Val(EditY2.Text, y2, Code);
  end;
 Val(EditIter.Text, MaxIter, Code);
 Val(EditDiam.Text, Diam, Code);

end;

Procedure TControl_Panel.Triangles(Sender: TObject);

var nn,i: Integer;
   TrezX,TRezY    :Double;

Procedure Paleta(n: Integer; var Red, Green, Blue: Byte);

var t: Double;

begin
 t := 2 * pi * exp( 10.4 * n / MaxIter );
 Red := 127 + Trunc( 127 * cos( 7.3 * t ) );
 Green := 127 + Trunc( 127 * COS( 8.15 * t ) );
 Blue := 127 + Trunc( 127 * cos( 9.1 * t ) );
 If n = MaxIter Then begin Red := 255; Green := 255; Blue := 0; end;
end;

Procedure TransfOfPoint(M: TPoint; var Mc: TPoint);

var Error: String;

begin
 with draw2d do
 begin
 x:=M[1];y:=M[2];
 Mc[1] := PostCalc(ExpressG1,Error);
 Mc[2] := PostCalc(ExpressG2,Error);
 end;
end;

Function Norm(X, Y: TPoint): Double;

begin
 Norm := sqrt( ( X[1] - Y[1] ) * ( X[1] - Y[1] )
  + ( X[2] - Y[2] ) * ( X[2] - Y[2] ) );
end;

begin
 Setting;
 Stop := False;

 With Draw2D Do
  begin
   ExpressG1 := PreCalc(EditG1.Text, Error);
   ExpressG2 := PreCalc(EditG2.Text, Error);
   Visible := True;
   Scale(x1, x2, y1, y2);
   hx := ( x2 - x1 ) / Image1.Width;
   hy := ( y2 - y1 ) / Image1.Height;
   x := x1;
   Repeat
    y := y1;
    Repeat
     A[1] := x; A[2] := y;
     B:=A;
     nn := 0;
     TrezX:=x;TrezY:=y;
     Repeat
      Inc(nn);
      TransfOfPoint(A, Ac);
      r := Norm(A, Ac);
      A := Ac;
     Until ( nn >= MaxIter ) Or ( r > Diam );
     x:=TrezX;y:=TrezY;
     Paleta(nn, Red, Green, Blue);
     A[1] := x; A[2] := y;
     PutPoint(A, Red, Green, Blue);
     y := y + hy;
    Until y > y2;
    x := x + hx;
    Image1.Repaint;
    Application.ProcessMessages;
    If Stop Then System.Exit;
   Until x > x2;
  end;
end;

Procedure TControl_Panel.Exit(Sender: TObject);

begin
 Draw2D.Visible := False;
 Halt;
end;

Procedure TControl_Panel.SetGraph2D(Sender: TObject);

var Code: Integer;

begin
 Application.CreateForm(TDraw2D, Draw2D);
 With Draw2D Do
  begin
   ClientWidth:=600;ClientHeight:=600;
   InitImage(600, 600);
   ClearImage(255, 255, 255);
   Caption:='Non-Linear equation system';
   Visible := True;
   Val(EditX1.Text, x1, Code);
   Val(EditX2.Text, x2, Code);
   Val(EditY1.Text, y1, Code);
   Val(EditY2.Text, y2, Code);
  end;
  Val(EditIter.Text, MaxIter, Code);
end;

Procedure TControl_Panel.SetY2(Sender: TObject);

var Vypis: String;
    Code: Integer;

begin
 With Draw2D Do
  begin
   Val(EditX1.Text, x1, Code);
   Val(EditX2.Text, x2, Code);
   Val(EditY1.Text, y1, Code);
   y2 := y1 + ( x2 - x1 ) * Image1.Height / Image1.Width;
   Str(Y2:5:3, Vypis);
  end;
  EditY2.Text := Vypis;
end;

Procedure TControl_Panel.SetStop(Sender: TObject);

begin
 Stop:=True;
end;

Procedure TControl_Panel.ImageSave(Sender: TObject);

begin
 If SavePictureDialog1.Execute Then
  Draw2D.Image1.Picture.SaveToFile(SavePictureDialog1.FileName);
end;


end.
