unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    Button1: TButton;
    Button2: TButton;
    StaticText5: TStaticText;
    EditX1: TEdit;
    EditX2: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    StaticText2: TStaticText;
    StaticText7: TStaticText;
    EditWatter: TEdit;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText1: TStaticText;
    EditLowLands: TEdit;
    EditMountains: TEdit;
    StaticText6: TStaticText;
    StaticText8: TStaticText;
    EditMaxLevels: TEdit;
    StaticText9: TStaticText;
    EditEq: TEdit;
    StaticText11: TStaticText;
    StaticText12: TStaticText;
    Button3: TButton;
    StaticText10: TStaticText;
    procedure Construction(Sender: TObject);
{    procedure Init(Sender: TObject);}
    procedure Konec(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
    procedure SetStop(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    Eq,ErrorReport:String;
  end;

var
  Control_Panel: TControl_Panel;
  Stop         : Boolean;
implementation

uses Graph2D_2005;

{$R *.DFM}

procedure TControl_Panel.Construction(Sender: TObject);
Type TColor = record R,G,B :Byte; end;
  var Max,Min        :Double;
      i,j,Adr        :integer;
      m,n1,n2,n3,n4  :Integer;
      Hodn           :Double;
      E,F            :TPixel;
      Pal            :array [0..5000] of TColor;
      PointOnScanrow :PByteArray;
      Expression     :TExpression;

 Procedure TopoPalette(n:Integer;var Red,Green,Blue:Byte);
  var r,g,b :array[0..5] of byte;
      uzel     :array[0..5] of integer;
      i        :Integer;
      t        :Double;
  begin
   r[0]:=0;  g[0]:=25; b[0]:=230;
   r[1]:=240;g[1]:=240;b[1]:=255; {voda}
   r[2]:=0  ;g[2]:=170;b[2]:=5; {nizina hladina more}
   r[3]:=255;g[3]:=255;b[3]:=255; {prechod nizina-vysocina}
   r[4]:=255;g[4]:=255;b[4]:=133;{vysocina}
   r[5]:=100;g[5]:=63; b[5]:=12; {hory}

   uzel[0]:=0;uzel[1]:=n1;uzel[2]:=n1;
   uzel[3]:=n2;uzel[4]:=n3;uzel[5]:=n4;

   i:=0;
   While n>uzel[succ(i)] do i:=succ(i);
   t:=(n-uzel[i])/(uzel[i+1]-uzel[i]);
   Red:=Trunc(r[i]+t*(r[i+1]-r[i]));
   Green:=Trunc(g[i]+t*(g[i+1]-g[i]));
   Blue:=Trunc(b[i]+t*(b[i+1]-b[i]));
  end;

  procedure Setting;
  var Number:Double;
      i,Code :Integer;
  begin
   Val(EditX1.Text,Number,Code);Draw2D.x1:=Number;
   Val(EditX2.Text,Number,Code);Draw2D.x2:=Number;
   Val(EditY1.Text,Number,Code);Draw2D.y1:=Number;
   Val(EditY2.Text,Number,Code);Draw2D.y2:=Number;
   Val(EditMaxLevels.Text,Number,Code);n4:=Trunc(Number);
   Val(EditWatter.Text,Number,Code);n1:=Trunc(Number);
   Val(EditLowLands.Text,Number,Code);n2:=Trunc(Number);
   Val(EditMountains.Text,Number,Code);n3:=Trunc(Number);
   Eq:=EditEq.Text;Stop:=False;
   for i:=0 to n4 do TopoPalette(i,Pal[i].R,Pal[i].G,Pal[i].B);
  end;


begin
  Setting;
  With Draw2D do
  begin
  hx:=(x2-x1)/Image1.Width;
  hy:=(y2-y1)/Image1.Height;
{*************************************}
{***** Stanoveni oboru hodnot ********}
{*************************************}
  y:=y1;
  Expression:=PreCalc(Eq,ErrorReport);
  Min:=Max;i:=0;
  Repeat
    x:=x1;E[1]:=0;F[1]:=1;E[2]:=i;F[2]:=i;
    Repeat
      Hodn:=PostCalc(Expression,ErrorReport);
      if Hodn>max then Max:=hodn else if hodn<Min then Min:=hodn;
      x:=x+hx;
    Until x>x2-hx;
    y:=y+hy;i:=succ(i);
    PutPixel(E,200,0,0);PutPixel(F,200,0,0);
    Image1.Repaint;
  until y>y2-hy;
  Scale(x1,x2,y1,y2);
  y:=y1;j:=0;
  Repeat
   x:=x1;i:=0;PointOnScanRow:=Image1.Picture.BitMap.ScanLine[j];
   Repeat
      Hodn:=PostCalc(Expression,ErrorReport);
      m:=Round((hodn-Min)*n4/(Max-Min))+2;
      Adr:=3*i;
      PointOnScanRow[succ(succ(Adr))]:=Pal[m].R;
      PointOnScanRow[succ(Adr)]:=Pal[m].G;
      PointOnScanRow[Adr]:=Pal[m].B;
      inc(i);x:=x+hx;
    Until x>x2-hx;
    y:=y+hy;inc(j);
    Image1.Repaint;
    Application.ProcessMessages;
    if stop then exit;
  until y>y2-hy;
 end;
end;

procedure TControl_Panel.Konec(Sender: TObject);
begin
  Draw2D.Visible:=False;Halt;
end;


procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    Top:=100;Left:=350;
    ClientHeight:=700;ClientWidth:=700;
    InitImage(700,700);ClearImage(255,255,255);
    Caption:='Function z=f(x,y) - Topopalette';
    Visible:=True;
  end;
end;

procedure TControl_Panel.SetStop(Sender: TObject);
begin
   Stop:=TRue;
end;


end.
